class ServiceConfig {
  static config = {}

  add(sequential, { isFixColumn = false, ignoreColor = true, ignorePrepMode = true } = {}) {
    ServiceConfig.config[sequential] = {
      isFixColumn,
      ignoreColor,
      ignorePrepMode,
    }
  }

  getConfig(sequential) {
    return ServiceConfig.config[sequential] || {};
  }

  hasColorValidation(sequential) {
    const servConfig = this.getConfig[sequential];
    return servConfig && !servConfig.isFixColumn && !servConfig.ignoreColor;
  }

  hasPrepModeValidation(sequential) {
    const servConfig = this.getConfig[sequential];
    return servConfig && !servConfig.isFixColumn && !servConfig.ignorePrepMode;
  }

  hasIngredientValidation(sequential) {
    const servConfig = this.getConfig(sequential);
    return servConfig && !servConfig.isFixColumn;
  }

  clear() {
    ServiceConfig.config = {};
  }
}

module.exports = new ServiceConfig();