class DeepCopy {
  replacer(key, value) {
    if (value instanceof Set) {
      return { __isSet__: true, values: Array.from(value) };
    }
    return value;
  }

  reviver(key, value) {
    if (value && typeof value === 'object' && '__isSet__' in value) {
      return new Set(value.values);
    }
    return value;
  }

  execute(data) {
    const copiedData = JSON.parse(JSON.stringify(data, this.replacer))
    return JSON.parse(JSON.stringify(copiedData), this.reviver)
  }
}

module.exports = new DeepCopy();